CREATE TABLE ADMIN_TOKENS
(
  TOKEN             VARCHAR2(64 CHAR)           NOT NULL,
  CREATION_DATE     DATE                        DEFAULT SYSDATE               NOT NULL,
  LOGIN_ALIAS       VARCHAR2(256 CHAR)          NOT NULL,
  LOGIN_ALIAS_TYPE  VARCHAR2(32 BYTE)           NOT NULL,
  BRAND             VARCHAR2(256 BYTE),
  SERVICE_URL       VARCHAR2(4000 CHAR),
  HTTP_METHOD       VARCHAR2(8 CHAR),
  EXPIRY_DATE       DATE                        NOT NULL,
  USAGE_LIMIT       NUMBER(8)                   DEFAULT 1                     NOT NULL,
  USAGE_COUNT       NUMBER(8)                   DEFAULT 0                     NOT NULL
);

CREATE UNIQUE INDEX ADMIN_TOKENS_PK ON ADMIN_TOKENS 
(TOKEN);

ALTER TABLE ADMIN_TOKENS ADD (
  CONSTRAINT ADMIN_TOKENS_PK
  PRIMARY KEY
  (TOKEN)
  USING INDEX ADMIN_TOKENS_PK
  ENABLE VALIDATE);
  
CREATE TABLE IDEMPOTENT_REQUEST_LOG
(
  REQUEST_ID        VARCHAR2(256 CHAR)          NOT NULL,
  CARD_REFERENCE    VARCHAR2(256 CHAR)          NOT NULL,
  API_COMMAND       VARCHAR2(64 BYTE)           NOT NULL,
  SERVICE_URL       VARCHAR2(4000 CHAR)         NOT NULL,
  REQUEST_DATE      DATE                        NOT NULL,
  RESPONSE_CODE     NUMBER(3),
  RESPONSE_CONTENT  VARCHAR2(4000 CHAR)
);

CREATE UNIQUE INDEX IDEMPOTENT_REQUEST_LOG_PK ON IDEMPOTENT_REQUEST_LOG
(REQUEST_ID, CARD_REFERENCE, API_COMMAND);

ALTER TABLE IDEMPOTENT_REQUEST_LOG ADD (
  CONSTRAINT IDEMPOTENT_REQUEST_LOG_PK
  PRIMARY KEY
  (REQUEST_ID, CARD_REFERENCE, API_COMMAND)
  USING INDEX IDEMPOTENT_REQUEST_LOG_PK
  ENABLE VALIDATE);